import os
import inspect

from ensemble.lib.testing import TestCase
from ensemble.formula import tests
from ensemble.formula.provider import get_formula_from_path

sample_directory = os.path.join(
    os.path.dirname(inspect.getabsfile(tests)), "repository", "dummy")


class FormulaFromPathTest(TestCase):

    def test_formula_from_oath(self):
        # from a directory
        formula = get_formula_from_path(sample_directory)
        assert formula.get_sha256()

        filename = self.makeFile(suffix=".frml")
        formula.make_archive(filename)

        # and from a bundle
        formula = get_formula_from_path(filename)
        self.assertEquals(formula.path, filename)
        self.assertInstance(formula.get_sha256(), basestring)

        # and validate the implementation detail that calling it twice
        # doesn't result in an error after caching the callable
        formula = get_formula_from_path(filename)
        self.assertEquals(formula.path, filename)
        self.assertInstance(formula.get_sha256(), basestring)
