import urllib2
import urllib
import httplib
import os

from twisted.internet.defer import succeed, fail
from ensemble.errors import (
    FileNotFound)

class HttpStorage(object):

    def __init__(self, base_url):
        self._base_url = base_url

    @property
    def path(self):
        # not part of the api, just for test cleanup
        return self._path

    def _key_to_url(self, name):
        return "%s/%s" % (self._base_url, name)

    def get(self, name):
        url = self._key_to_url(name)
        return succeed(urllib.urlretrieve(url)[0])

    def put(self, remote_path, local_path):
        local_path = os.path.abspath(local_path)
        if not os.path.exists(local_path):
            return fail(FileNotFound(local_path))

        store_url = self._key_to_url(remote_path)
        req = urllib2.Request(store_url)
        connection = httplib.HTTPConnection(req.get_host())
        with open(local_path,'r') as local:
            connection.request('PUT', req.get_selector(), local)
            result = connection.getresponse()
            if str(result.status)[0] != '2':
                return fail(Exception('%s:%s' % (result.status, result.reason)))

        return succeed(True)
